package com.kmall.admin.service;

import com.kmall.admin.entity.FreightItemEntity;

import java.util.List;
import java.util.Map;

/**
 * Service接口
 *
 * @author emato
 * @email admin@qhdswl.com
 * @date 2018-10-22 15:18:16
 */
public interface FreightItemService {

    /**
     * 根据主键查询实体
     *
     * @param id 主键
     * @return 实体
     */
    FreightItemEntity queryObject(Integer id);

    /**
     * 分页查询
     *
     * @param map 参数
     * @return list
     */
    List<FreightItemEntity> queryList(Map<String, Object> map);

    /**
     * 分页统计总数
     *
     * @param map 参数
     * @return 总数
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存实体
     *
     * @param freightItem 实体
     * @return 保存条数
     */
    int save(FreightItemEntity freightItem);

    /**
     * 根据主键更新实体
     *
     * @param freightItem 实体
     * @return 更新条数
     */
    int update(FreightItemEntity freightItem);

    /**
     * 根据主键删除
     *
     * @param id
     * @return 删除条数
     */
    int delete(Integer id);

    /**
     * 根据主键批量删除
     *
     * @param ids
     * @return 删除条数
     */
    int deleteBatch(Integer[] ids);

    int deleteByFreId(Integer freId);
}
