package com.kmall.api.dao;

import com.kmall.api.entity.ProductVo;
import org.apache.ibatis.annotations.Param;
import com.kmall.common.dao.BaseDao;
import org.springframework.stereotype.Component;

/**
 * @author Scott
 * @email
 * @date 2017-08-11 09:16:46
 */
@Component
public interface ApiProductMapper extends BaseDao<ProductVo> {
    ProductVo queryObjectByStoreId(@Param("id") Long id, @Param("store_id") Long store_id);

    /**
     * 根据门店查找库存最大的产品
     *
     * @param goods_id
     * @param store_id
     * @return
     */
    ProductVo queryOneByGoodsId(@Param("goods_id") Long goods_id, @Param("store_id") Long store_id);

    /**
     * 更新库存
     *
     * @return
     */
    void updateStockNum(ProductVo productVo);

    /**
     * 更新销售量
     *
     * @return
     */
    void updateSellVolumeNum(ProductVo productVo);

}
